Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.transaction.interceptor
Class AbstractFallbackTransactionAttributeSource

    java.lang.Object
      org.springframework.transaction.interceptor.AbstractFallbackTransactionAttributeSource

All Implemented Interfaces:
  TransactionAttributeSource

Direct Known Subclasses:
  AnnotationTransactionAttributeSource, AttributesTransactionAttributeSource

    public abstract class AbstractFallbackTransactionAttributeSource

extends Object
implements TransactionAttributeSource

Abstract implementation of `TransactionAttributeSource` that caches attributes for methods and implements a fallback policy: 1. specific target method; 2. target class; 3. declaring method; 4. declaring class/interface.

Defaults to using the target class's transaction attribute if none is associated with the target method. Any transaction attribute associated with the target method completely overrides a class transaction attribute. If none found on the target class, the interface that the invoked method has been called through (in case of a JDK proxy) will be checked.

This implementation caches attributes by method after they are first used. If it is ever desirable to allow dynamic changing of transaction attributes (which is very unlikely), caching could be made configurable. Caching is desirable because of the cost of evaluating rollback rules.

Since:
  1.1
Author:
  Rod Johnson, Juergen Hoeller

Field Summary
`protected Log` | `logger` Logger available to subclasses.

Constructor Summary
`AbstractFallbackTransactionAttributeSource()`

Method Summary
`protected boolean` | `allowPublicMethodsOnly()` Should only public methods be allowed to have transactional semantics?
`protected abstract Collection` | `findAllAttributes(Class clazz)` Subclasses should implement this to return all attributes for this class.
`protected abstract Collection` | `findAllAttributes(Method method)` Subclasses should implement this to return all attributes for this method.
`protected TransactionAttribute` | `findTransactionAttribute(Collection atts)` Return the transaction attribute, given this set of attributes attached to a method or class.
`protected Object` | `getCacheKey(Method method, Class targetClass)` Determine a cache key for the given method and target class.
`TransactionAttribute` | `getTransactionAttribute(Method method, Class targetClass)` Determine the transaction attribute for this method invocation.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final Log logger

  Logger available to subclasses.

  As this base class is not marked Serializable, the logger will be recreated after serialization - provided that the concrete subclass is Serializable.

Constructor Detail

### AbstractFallbackTransactionAttributeSource

    public AbstractFallbackTransactionAttributeSource()

Method Detail

### getTransactionAttribute

    public TransactionAttribute getTransactionAttribute(Method method,
                                                        Class targetClass)

  Determine the transaction attribute for this method invocation.

  Defaults to the class's transaction attribute if no method attribute is found.

  Specified by:
    `getTransactionAttribute` in interface `TransactionAttributeSource`
  Parameters:
    `method` - the method for the current invocation (never `null`)
    `targetClass` - the target class for this invocation (may be `null`)
  Returns:
    TransactionAttribute for this method, or `null` if the method is not transactional

### getCacheKey

    protected Object getCacheKey(Method method,
                                 Class targetClass)

  Determine a cache key for the given method and target class.

  Must not produce same key for overloaded methods. Must produce same key for different instances of the same method.

  Parameters:
    `method` - the method (never `null`)
    `targetClass` - the target class (may be `null`)
  Returns:
    the cache key (never `null`)

### findAllAttributes

    protected abstract Collection findAllAttributes(Method method)

  Subclasses should implement this to return all attributes for this method. We need all because of the need to analyze rollback rules.

  Parameters:
    `method` - the method to retrieve attributes for
  Returns:
    all attributes associated with this method (may be `null`)

### findAllAttributes

    protected abstract Collection findAllAttributes(Class clazz)

  Subclasses should implement this to return all attributes for this class.

  Parameters:
    `clazz` - class to retrieve attributes for
  Returns:
    all attributes associated with this class (may be `null`)

### findTransactionAttribute

    protected TransactionAttribute findTransactionAttribute(Collection atts)

  Return the transaction attribute, given this set of attributes attached to a method or class.

  Protected rather than private as subclasses may want to customize how this is done: for example, returning a TransactionAttribute affected by the values of other attributes.

  This implementation takes into account RollbackRuleAttributes, if the TransactionAttribute is a RuleBasedTransactionAttribute.

  Parameters:
    `atts` - attributes attached to a method or class (may be `null`)
  Returns:
    TransactionAttribute the corresponding transaction attribute, or `null` if none was found

### allowPublicMethodsOnly

    protected boolean allowPublicMethodsOnly()

  Should only public methods be allowed to have transactional semantics?

  The default implementation returns `false`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2007 The Spring Framework.